<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
/**
 * JA Param K2 Helper
 *
 * @since      Class available since Release 1.2.0
 */
class JElementCategoryK2 extends JElement
{
    /*
	 * Category name
	 *
	 * @access	protected
	 * @var		string
	 */
    var $_name = 'CategoryK2';

    var $_controlName = '';


    /**
     * Fetch Ja Element Param method
     *
     * @param 	string	$name The name of ja element param.
     * @param	string	$value The value of element
     * @param	object	$node The node of element
     * @param	string	$control_name
     * @return	object  param
     */
    function fetchElement($name, $value, &$node, $control_name)
    {
        if (!$this->checkComponent('com_k2')) {
            return '<input type="hidden" name="' . $control_name . '[' . $name . ']" id="' . $control_name . $name . '"/> <span style="color:red">K2 component is not installed!</span>';
        }
        $this->_controlName = $name;
        $categories = JElementCategoryK2::_fetchElement(0, '', array());

        $check = '';
        if (!is_array($value) && $value == '') {
            $check = 'selected="selected"';
        }

        $HTMLCats = '<select name="' . $control_name . '[' . $name . '][]" id="' . $control_name . $name . '" class="inputbox" style="width:95%;" multiple="multiple" size="10">';
        $HTMLCats .= '<option value="" ' . $check . ' >' . JText::_("ALL CATEGORY") . '</option>';

        foreach ($categories as $item) {
            //if(!$item->haschild) continue;
            $check = '';
            if ((is_array($value) && in_array($item->id, $value)) || (!is_array($value) && $item->id == $value)) {
                $check = 'selected="selected"';
            }

            $class = '';
            if (!$item->haschild)
                $class = 'class="subcat"';

            $HTMLCats .= '<option value="' . $item->id . '" ' . $check . ' ' . $class . '>' . '&nbsp;&nbsp;&nbsp;' . $item->treename . '</option>';
        }

        $HTMLCats .= '</select>';
        return $HTMLCats;
    }


    /**
     *
     * Get data from Sub Category K2 database
     * @param int $parent parent category id
     * @return array list object categories child
     */
    function fetchChild($parent)
    {
        $db = &JFactory::getDBO();
        $query = "SELECT * FROM #__k2_categories WHERE parent = '{$parent}' AND published=1";
        $db->setQuery($query);
        $cats = $db->loadObjectList();

        return $cats;
    }


    /**
     *
     * Show element data on K2
     * @param int $id
     * @param strig $indent
     * @param array $list
     * @param int $maxlevel
     * @param int $level
     * @param int $type
     * @return array list categories element
     */
    function _fetchElement($id, $indent, $list, $maxlevel = 9999, $level = 0, $type = 1)
    {
        $children = JElementCategoryK2::fetchChild($id);

        if (@$children && $level <= $maxlevel) {
            foreach ($children as $v) {
                $id = $v->id;

                if ($type) {
                    $pre = '<sup>|_</sup>&nbsp;';
                    $spacer = '.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                } else {
                    $pre = '- ';
                    $spacer = '&nbsp;&nbsp;';
                }

                if ($v->parent == 0) {
                    $txt = $v->name;
                } else {
                    $txt = $pre . $v->name;
                }
                $pt = $v->parent;
                $list[$id] = $v;
                $list[$id]->treename = "{$indent}{$txt}";
                $list[$id]->children = count(@$children);
                $list[$id]->haschild = true; //print_r($list);echo '<br/><br/>';
                $list = JElementCategoryK2::_fetchElement($id, $indent . $spacer, $list, $maxlevel, $level + 1, $type);
            }
        } else {
            $list[$id]->haschild = false;
        }
        return $list;
    }


    /**
     *
     * Check component is existed
     * @param string $component component name
     * @return int return > 0 when component is installed
     */
    function checkComponent($component)
    {
        $db = JFactory::getDBO();
        $query = " SELECT Count(*) FROM #__components as c WHERE c.option ='$component' and c.parent=0";
        $db->setQuery($query);
        return $db->loadResult();
    }
}
?>