<?php

// Ensure this file is being included by a parent file
defined('_JEXEC') or die('Restricted access');
/**
 * Radio List Element
 *
 * @since      Class available since Release 1.2.0
 */
class JElementThemes extends JElement
{


    /**
     * Fetch Ja Element Param method
     *
     * @param 	string	$name The name of ja element param.
     * @param	string	$value The value of element
     * @param	object	$node The node of element
     * @param	string	$control_name
     * @return	object  param
     */
    function fetchElement($name, $value, &$node, $control_name)
    {
        $uri = str_replace(DS, "/", str_replace(JPATH_SITE, JURI::base(), dirname(__FILE__)));
        $uri = str_replace("/administrator", "", $uri);
        if (!defined('japaramhelper2')) {
            JHTML::stylesheet('japaramhelper2.css', $uri . "/assets/css/");
            JHTML::script('japaramhelper2.js', $uri . "/assets/js/");

            jimport('joomla.filesystem.folder');
            jimport('joomla.filesystem.file');

            define('japaramhelper2', true);
        }

        /* Get all themes name folder from folder themes */
        $themes = array();

        // get in module
        $path = JPATH_SITE . DS . 'modules' . DS . 'mod_janews_fp' . DS . 'tmpl';
        if (!JFolder::exists($path))
            return JText::_('Themes Folder not exist');
        $folders = JFolder::folders($path);
        if ($folders) {
            foreach ($folders as $fname) {
                $themes[$fname] = $fname;
            }
        }

        // get in template
        $template = JElementJaparamhelper2::get_active_template();
        $path = JPATH_SITE . DS . 'templates' . DS . $template . DS . 'html' . DS . 'mod_janews_fp';
        if (JFolder::exists($path)) {
            $folders = JFolder::folders($path);
            if ($folders) {
                foreach ($folders as $fname) {
                    $themes[$fname] = $fname;
                }
            }
        }

        $HTMLThemes = array();
        if ($themes) {
            foreach ($themes as $fname) {
                //
                $f = new stdClass();
                $f->id = $fname;
                $f->title = $fname;
                array_push($HTMLThemes, $f);
            }
        }

        $html = JHTML::_('select.genericlist', $HTMLThemes, $control_name . '[' . $name . ']', 'style="width:150px; position:relative" onchange="japarams2.changeTheme(this.value, false)"', 'id', 'title', $value);

        return $html;
    }
}