<?php

if (!defined('FLEXI_SECTION')) {
    $cparams = & JComponentHelper::getParams('com_flexicontent');
    define('FLEXI_SECTION', $cparams->get('flexi_section'));
}
if (!class_exists('JAFlexiHelperFP')) {
    /**
     * News Front Page Module JA Flexi Helper
     *
     * @package		Joomla
     * @subpackage	Content
     * @since 		1.5
     */
    class JAFlexiHelperFP
    {


        /**
         *
         * Get Articles of Flexi
         * @param object $helper
         * @param object $params
         * @return object
         */
        function getArticles(&$helper, $params)
        {
            if (file_exists(JPATH_SITE . DS . 'components' . DS . 'com_flexicontent' . DS . 'helpers' . DS . 'route.php')) {
				require_once (JPATH_SITE . DS . 'components' . DS . 'com_flexicontent' . DS . 'helpers' . DS . 'route.php');
				require_once (JPATH_SITE . DS . 'components' . DS . 'com_flexicontent' . DS . 'models' . DS . 'items.php');
			}
			else {
				return array();
			}

            $helper->set('getFlexiChildren', $params->get('getFlexiChildren', 1));
            $catsid = $params->get('flexi_catsid');
            $catids = array();
            if (!is_array($catsid)) {
                $catids[] = $catsid;
            } else {
                $catids = $catsid;
            }

            JArrayHelper::toInteger($catids);
            if ($catids) {
                if ($catids && count($catids) > 0) {
                    foreach ($catids as $k => $catid) {
                        if (!$catid)
                            unset($catids[$k]);
                    }
                }
            }

            jimport('joomla.filesystem.file');
            $limit = (int) $helper->get('limit', 10);
            if (!$limit)
                $limit = 4;
            $limitstart = (int) $helper->get('limitstart', 0);
            $ordering = $helper->get('ordering', '');

            $user = &JFactory::getUser();
            $aid = $user->get('aid');
            $db = &JFactory::getDBO();

            $jnow = &JFactory::getDate();
            $now = $jnow->toMySQL();
            $nullDate = $db->getNullDate();
		    $query ='SELECT i.*, ie.search_index AS searchindex, i.catid AS maincat, rel.catid AS catid, u.name AS editor, t.name AS type_name, g.name AS groupname, rel.ordering AS catsordering, (SELECT name
				  FROM #__users
				  WHERE id = i.created_by) AS author
				  FROM #__content AS i
				  LEFT JOIN #__flexicontent_items_ext AS ie
				  ON ie.item_id = i.id
				  LEFT JOIN #__flexicontent_cats_item_relations AS rel
				  ON rel.itemid = i.id
				  LEFT JOIN #__flexicontent_types AS t
				  ON t.id = ie.type_id
				  LEFT JOIN #__groups AS g
				  ON g.id = i.access
				  LEFT JOIN #__users AS u
				  ON u.id = i.checked_out
				  WHERE  i.state != -1
				  AND  i.state != -2
				  AND  i.sectionid = '.FLEXI_SECTION;

		if ($catids) {
                $catids_new = $catids;
                if ($helper->get('getFlexiChildren')) {
                    foreach ($catids as $k => $catid) {
                        $subcatids = $this->getCategoryChilds($catid, true);
                        if ($subcatids) {
                            $catids_new = array_merge($catids_new, array_diff($subcatids, $catids_new));
                        }
                    }
                }
                $catids = implode(',', $catids_new);
                $query .= "\n AND rel.catid in ($catids)";
            }

            if ($ordering == 'rand')
                $query .= "\n ORDER BY RAND()";
            else
                $query .= "\n ORDER BY i." . $ordering;
            $db->setQuery($query, $limitstart, $limit);
            $rows = $db->loadObjectList();
            //var_dump($db->GetQuery());
            $autoresize = intval(trim($helper->get('autoresize', 1)));

            $img_align = trim($helper->get('align', 'left'));
            $hiddenClasses = trim($helper->get('hiddenClasses', ''));

            $bigmaxchar = $helper->get('bigmaxchars', 200);
            $bigimg_w = $helper->get('bigimg_w', 150);
            $bigimg_h = $helper->get('bigimg_h', 100);
            $bigshowimage = $helper->get('bigshowimage', 1);

            $smallmaxchar = $helper->get('smallmaxchars', 100);
            $smallimg_w = $helper->get('smallimg_w', 80);
            $smallimg_h = $helper->get('smallimg_h', 80);
            $smallshowimage = $helper->get('smallshowimage', 1);

            if ($helper->get('JPlugins', 1)) {
                JPluginHelper::importPlugin('content');
                $dispatcher = & JDispatcher::getInstance();
            }
            if (count($rows)) {

                foreach ($rows as $j => $row) {
                    $helper->_params->set('parsedInModule', 1);
                    $row->text = $row->introtext;
                    if ($helper->get('JPlugins', 1)) {
                        $row->event = new stdClass();
                        $results = $dispatcher->trigger('onPrepareContent', array(& $row, &$helper->_params, $limitstart));
                        $row->event->afterDisplayTitle = trim(implode("\n", $results));

                        $results = $dispatcher->trigger('onAfterDisplayTitle', array(& $row, &$helper->_params, $limitstart));
                        $row->event->afterDisplayTitle = trim(implode("\n", $results));

                        $results = $dispatcher->trigger('onBeforeDisplayContent', array(& $row, &$helper->_params, $limitstart));
                        $row->event->beforeDisplayContent = trim(implode("\n", $results));

                        $results = $dispatcher->trigger('onAfterDisplayContent', array(& $row, &$helper->_params, $limitstart));
                        $row->event->afterDisplayContent = trim(implode("\n", $results));

                    }

                    $row->link = JRoute::_(FlexicontentHelperRoute::getItemRoute($row->id, $row->catid));
                    $row->bigimage = $helper->replaceImage($row, $img_align, $autoresize, $bigmaxchar, $bigshowimage, $bigimg_w, $bigimg_h, $hiddenClasses);
                    $row->bigintrotext = $row->introtext1;
                    if ($bigmaxchar == 0)
                        $row->bigintrotext = '';
                    $row->introtext = $row->text;
                    $row->smallimage = $helper->replaceImage($row, $img_align, $autoresize, $smallmaxchar, $smallshowimage, $smallimg_w, $smallimg_h, $hiddenClasses);
                    $row->smallintrotext = $row->introtext1;
                    if ($smallmaxchar == 0)
                        $row->smallintrotext = '';
                    $rows[$j] = $row;
                }
            }

            return $rows;
        }

        /**
         *
         * Get total Flexi items
         * @param object $helper
         * @param object $params
         * @return int
         */
        function getTotal(&$helper, $params)
        {
            if (file_exists(JPATH_SITE . DS . 'components' . DS . 'com_flexicontent' . DS . 'helpers' . DS . 'route.php')) {
				require_once (JPATH_SITE . DS . 'components' . DS . 'com_flexicontent' . DS . 'helpers' . DS . 'route.php');
				require_once (JPATH_SITE . DS . 'components' . DS . 'com_flexicontent' . DS . 'models' . DS . 'items.php');
			}
			else {
				return;
			}
            $helper->set('getChildren', $params->get('getChildren', 1));
            $catsid = $params->get('k2catsid');
            $catids = array();
            if (!is_array($catsid)) {
                $catids[] = $catsid;
            } else {
                $catids = $catsid;
            }

            JArrayHelper::toInteger($catids);
            if ($catids) {
                if ($catids && count($catids) > 0) {
                    foreach ($catids as $k => $catid) {
                        if (!$catid)
                            unset($catids[$k]);
                    }
                }
            }

            $user = &JFactory::getUser();
            $aid = $user->get('aid');
            $db = &JFactory::getDBO();

            $jnow = &JFactory::getDate();
            $now = $jnow->toMySQL();
            $nullDate = $db->getNullDate();

		    $query ='SELECT count(i.id), (SELECT name
				  FROM #__users
				  WHERE id = i.created_by) AS author
				  FROM #__content AS i
				  LEFT JOIN #__flexicontent_items_ext AS ie
				  ON ie.item_id = i.id
				  LEFT JOIN #__flexicontent_cats_item_relations AS rel
				  ON rel.itemid = i.id
				  LEFT JOIN #__flexicontent_types AS t
				  ON t.id = ie.type_id
				  LEFT JOIN #__groups AS g
				  ON g.id = i.access
				  LEFT JOIN #__users AS u
				  ON u.id = i.checked_out
				  WHERE  i.state != -1
				  AND  i.state != -2
				  AND  i.sectionid = '.FLEXI_SECTION;

		    if ($catids) {
                $catids_new = $catids;
                if ($helper->get('getChildren')) {
                    foreach ($catids as $k => $catid) {
                        //$flexi = new FlexicontentModelCategory();
                        //	$flexi->setId($catid);
                        //	$subcatids = $flexi->getChilds();
                        $subcatids = $this->getCategoryChilds($catid, true);
                        if ($subcatids) {
                            $catids_new = array_merge($catids_new, array_diff($subcatids, $catids_new));
                        }
                    }
                }
                $catids = implode(',', $catids_new);
                $query .= "\n AND i.catid IN ($catids)";
            }

            $db->setQuery($query);
            return $db->loadResult();
        }


        /**
         *
         * Get Childs of Categories
         * @param int $catid
         * @param boolean $clear
         * @return array
         */
        function getCategoryChilds($catid, $clear = false)
        {

            static $array = array();
            if ($clear)
                $array = array();
            $user = &JFactory::getUser();
            $aid = (int) $user->get('aid');
            $catid = (int) $catid;
            $db = &JFactory::getDBO();
            //  $query = "SELECT * FROM #__k2_categories WHERE parent={$catid} AND published=1 AND trash=0 AND access<={$aid} ORDER BY ordering ";
            $query = "SELECT `id` FROM `#__categories`  " . "\n WHERE published = 1 " . "\n AND  parent_id='{$catid}' " . "\n ORDER BY ordering";
            $db->setQuery($query);
            $rows = $db->loadObjectList();

            foreach ($rows as $row) {
                array_push($array, $row->id);
                if ($this->hasChilds($row->id)) {
                    $this->getCategoryChilds($row->id);
                }
            }
            return $array;
        }


        /**
         *
         * Method check categories has childs
         * @param unknown_type $id
         */
        function hasChilds($id)
        {

            $id = (int) $id;
            $db = &JFactory::getDBO();
            $query = "SELECT * FROM #__categories WHERE parent_id={$id} AND published=1  ";
            $db->setQuery($query);
            $rows = $db->loadObjectList();

            if (count($rows)) {
                return true;
            } else {
                return false;
            }
        }
    }
}

?>